=== debian/changelog ===
firmware-microbit-micropython (1.0.1-4) unstable; urgency=medium

  * d/control:
    - Declare compliance with Debian Policy 4.6.2 (no changes)
  * d/copyright:
    - Bump years of Debian copyright
  * d/rules:
    - Build with -std=gnu++14 to fix FTBFS with new clang.
      Thanks to Adrian Bunk for the NMU (Closes: #1026600)
    - Refresh dh_auto_clean override
  * d/watch:
    - Switch to watching Github tags rather than releases

 -- Nick Morrott <nickm@debian.org>  Fri, 24 Feb 2023 03:25:18 +0000

firmware-microbit-micropython (1.0.1-3) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control:
    - Update Maintainer field with new Debian Python Team contact address.
    - Update Vcs-* fields with new Debian Python Team Salsa layout.

  [ Nick Morrott ]
  * d/control:
    - Update standards version to 4.6.0, no changes needed.
  * d/copyright:
    - Refresh years of Debian copyright
    - Use 4-digit years for Debian copyright ranges
  * d/s/lintian-overrides
    - Refresh overrides against current lintian
  * d/u/metadata:
    - Remove obsolete fields Contact, Name
  * d/watch:
    - Update pattern for GitHub archive URLs

 -- Nick Morrott <nickm@debian.org>  Tue, 15 Feb 2022 11:57:55 +0000

firmware-microbit-micropython (1.0.1-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat.

  [ Nick Morrott ]
  * d/control:
    - Bump Standards-Version to 4.5.0
    - Bump debhelper-compat level to 13
    - Set Rules-Requires-Root to no
    - Update Uploaders to use my Debian email address
    - Mark binary package as Multi-Arch: foreign
    - Suggest www-browser for documentation binary package
  * d/copyright:
    - Retab to remove extraneous tab characters
    - Refresh years of Debian copyright
  * d/patches:
    - Refresh patches (fuzz)
    - Add patch use-python3-in-makefile (Closes: #959640)
    - Add patch 1.0.1-documentation-fixes
  * d/{README.source,gbp.conf}:
    - Configure MUT components

 -- Nick Morrott <nickm@debian.org>  Wed, 17 Jun 2020 23:58:21 +0100

firmware-microbit-micropython (1.0.1-1) unstable; urgency=medium

  * Initial release (Closes: #908783)

 -- Nick Morrott <knowledgejunkie@gmail.com>  Sat, 19 Jan 2019 17:24:43 +0100
